#include <stdio.h>
#include <stdlib.h>
#include <SWI-Prolog.h>


/* from Quintus Prolog library */
long ctr[32];   /* These counters are visible to other C code */

#define CTR_INC 0
#define CTR_DEC 1
#define CTR_SET 2

foreign_t
ctr_val(term_t Counter, term_t result )
{
  int tmp;
  if (PL_get_integer( Counter, &tmp)){
	  PL_unify_integer(result, ctr[tmp&31]);
  }
  
  return TRUE;
}


foreign_t 
ctr_op2(term_t Counter, term_t NewValue, term_t Op)
{
  int op, counter;
  long newV;
  
  if (PL_get_integer(Op, &op) &&
	  PL_get_integer(NewValue, &newV) &&
	  PL_get_integer(Counter,  &counter)){	

		switch (op) {
		case CTR_INC: ctr[counter&31] += newV; break;
		case CTR_DEC: ctr[counter&31] -= newV; break;
		case CTR_SET: ctr[counter&31]  = newV; break;
	}
  }

  return TRUE;
}


foreign_t 
ctr_op3(term_t Counter, term_t NewValue, term_t Op, term_t result)
{
  int op, counter;
  long newV;

  if (PL_get_integer(Op, &op) && 
	  PL_get_integer(NewValue, &newV) &&
	  PL_get_integer(Counter,  &counter)){
  
	  register long *p = &ctr[counter&31];
	  register long OldValue = *p;

	  switch (op) {
	  case CTR_INC: *p += newV; break;
	  case CTR_DEC: *p -= newV; break;
	  case CTR_SET: *p  = newV; break;
	  }
	
	 PL_unify_integer(result, OldValue);
  } 

  return TRUE;
}

install_t
install(){
	PL_register_foreign("ctr_val", 2, ctr_val, 0);
	PL_register_foreign("ctr_op2", 3, ctr_op2, 0);
	PL_register_foreign("ctr_op3", 4, ctr_op3, 0);

}




